﻿[string]$deviceName
[string]$deviceID
[boolean]$sjekkdata1
[boolean]$sjekkdata2
[int]$fortsettsjekk
[string]$compName
[string]$confName
[string]$complID

#---------- Hjelpefunksjoner ----------
    
function getDeviceID{
    $script:deviceName = read-host "Enter the name of the device that you wish to operate"
    $script:deviceID = Get-IntuneManagedDevice | Where-Object devicename -eq $script:deviceName | Select-Object -ExpandProperty manageddeviceid
        
    if($deviceID -eq $null){
        write-host "The device does not exist!" -ForegroundColor red
        $fortsettsjekk = read-host "Press <1> to try again or <0> to go back to menu..."
        if ($fortsettsjekk -eq 1){
            clear-host
            getDeviceID
        }elseif ($fortsettsjekk -eq 0){
        clear-host
        meny2
        }else{
        clear-host
        write-host "unvalid entry..."
        getDeviceID
        }
    }      
}

function connect{
    install-module azuread
    install-module windowsautopilotintune
    Install-Module -Name Microsoft.Graph.Intune
    import-module windowsautopilotintune
    connect-MSGraph
    Connect-AzureAD 
    Connect-AutoPilotIntune -user admin@m365x750721.onmicrosoft.com
    }
    
#---------- Meny ---------- 

function hovedMenyIntune{
    #Funksjonen laster inn meny for Intune-funksjoner
    #Funksjonen benytter seg av 
    clear-host
    #nullstillVariabler
    [int]$Menyvalg = 0
    while($Menyvalg -lt 1 -or $Menyvalg -gt 6){
        write-host "========================= ~ Intune Management ~ ========================= `n" -ForegroundColor Cyan 
        write-host "1." -ForegroundColor cyan -NoNewline
        write-host " Azure AD Group Management`n" -ForegroundColor DarkCyan
        write-host "2." -ForegroundColor cyan -NoNewline
        write-host " Intune Device Management`n" -ForegroundColor DarkCyan
        write-host "3." -ForegroundColor cyan -NoNewline
        write-host " Windows Autopilot Management`n" -ForegroundColor DarkCyan
        write-host "4." -ForegroundColor cyan -NoNewline
        write-host " Device Compliance Policy Management`n" -ForegroundColor DarkCyan
        write-host "5." -ForegroundColor cyan -NoNewline
        write-host " Device Configuration Policy Management`n" -ForegroundColor DarkCyan
        write-host "6." -ForegroundColor cyan -NoNewline
        write-host " Client Apps Management`n" -ForegroundColor DarkCyan
        write-host "0. " -fore yellow -NoNewline
        write-host "Quit`n" -ForegroundColor DarkYellow

        [int]$Menyvalg = read-host "Enter a value between 0 and 6" 
        switch($Menyvalg){
            0{avslutt}       
            1{meny1}
            2{meny2}
            3{meny3}
            4{meny4}
            5{meny5}
            6{meny6}
            default{
            clear 
            write-host "Du valgte et tall utenfor menyvalggrensen..." -ForegroundColor yellow
            }
        }
    }
}

#---------- Users/groups ---------- 

function meny1{
    #Funksjonen laster inn meny for Intune-funksjoner
    #Funksjonen benytter seg av 
    #clear-host
    #nullstillVariabler
    [int]$Menyvalg = 0
    while($Menyvalg -lt 1 -or $Menyvalg -gt 7){
        write-host "`n`t============= ~ Intune Management - Azure AD User/Group Management ~ ============= `n" -ForegroundColor Cyan 
        write-host "`t1." -ForegroundColor cyan -NoNewline
        write-host " List AAD Users`n" -ForegroundColor DarkCyan
        write-host "`t2." -ForegroundColor cyan -NoNewline
        write-host " Create new AAD User`n" -ForegroundColor DarkCyan
        write-host "`t3." -ForegroundColor cyan -NoNewline
        write-host " Remove AAD User`n" -ForegroundColor DarkCyan
        write-host "`t4." -ForegroundColor cyan -NoNewline
        write-host " List AAD Groups`n" -ForegroundColor DarkCyan
        write-host "`t5." -ForegroundColor cyan -NoNewline
        write-host " List AAD Group Members`n" -ForegroundColor DarkCyan
        write-host "`t6." -ForegroundColor cyan -NoNewline
        write-host " Create New AAD Group`n" -ForegroundColor DarkCyan
        write-host "`t7." -ForegroundColor cyan -NoNewline
        write-host " Remove AAD Group`n" -ForegroundColor DarkCyan
        write-host "`t0." -ForegroundColor DarkYellow -NoNewline
        write-host " Back to Intune Management`n" -ForegroundColor DarkYellow

        [int]$Menyvalg = read-host "`tEnter a value between 0 and 7" 
        switch($Menyvalg){
            0{hovedMenyIntune}
            1{getAADUsers}
            2{newaaduser}
            3{removeAADUser}
            4{getAADGroup}       
            5{getAADGroupMember}
            6{newaadGroup}
            7{removeAADGroup}
            default{
            clear 
            write-host "Du valgte et tall utenfor menyvalggrensen..." -ForegroundColor yellow
            }
        }
    }
}

    function getAADUsers{
        #Funksjonen vil liste ut AAD brukere
        #Funksjonen benytter seg av funksjonen fortsettMeny1
        clear-host
        write-host "=========================== List AAD Users ===========================`n" -fore Cyan
        get-azureADUser | format-table displayname, userprincipalname
        fortsettMeny1
    }
    
    function newaaduser{
        #Funksjonen Oppretter en ny aad bruker
        #Funksjonen benytter seg av funksjonen fortsettMeny1
        clear-host
        write-host "========= Create AAD User =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter password: " -fore DarkCyan -NoNewline
        write-host "<**************>" -fore Yellow
        write-host "Enter first name: " -fore DarkCyan -NoNewline
        write-host "<Ola>" -fore Yellow
        write-host "Enter last name: " -fore DarkCyan -NoNewline
        write-host "<Nordmann>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan
        $PasswordProfile = New-Object -TypeName Microsoft.Open.AzureAD.Model.PasswordProfile
        [string]$passwordInput = read-host "Enter password" -AsSecureString 
        [string]$fornavn = read-host "Enter first name"
        [string]$etternavn = read-host "Enter last name"
        [string]$brukerNavn = $fornavn + " " + $etternavn
        [string]$brukerNavn1 = $fornavn + $etternavn
        [string]$domene = "@m365x750721.onmicrosoft.com"
        [string]$userPrinsNavn = $fornavn + $etternavn + $domene 
        $PasswordProfile.Password = $passwordInput

        [void](New-AzureADUser `
            -DisplayName $brukerNavn `
            -PasswordProfile $PasswordProfile `
            -UserPrincipalName $userPrinsNavn `
            -AccountEnabled $true `
            -MailNickName $brukerNavn1)
        write-host "`nUser: " -ForegroundColor Cyan -NoNewline
        write-host $userPrinsNavn -ForegroundColor Yellow -NoNewline
        write-host ", has been created!`n" -ForegroundColor Cyan -NoNewline
        fortsettMeny1
    }

    function removeAADUser{
        #Funksjonen vil slette en valgt bruker
        #Funksjonen benytter seg av funksjonen fortsettMeny1 og sjekkUserExist
        clear-host
        write-host "========= Delete AAD User =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter user principalname from list above: " -fore DarkCyan 
        write-host "<LidiaH@M365x949520.OnMicrosoft.com>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan
        get-azureADUser | format-table displayname, userprincipalname
        [string]$script:valgtUser = read-host "Enter user principalname from list above"
        sjekkUserExist
        [string]$brukerID = Get-AzureADUser | where-object userprincipalname -eq $script:valgtUser | Select-Object -ExpandProperty objectid
        
        
        Remove-AzureADUser -ObjectId $brukerID
        write-host "`nUser: " -ForegroundColor Cyan -NoNewline
        write-host $script:valgtUser -ForegroundColor Yellow -NoNewline
        write-host ", has been removed!`n" -ForegroundColor Cyan -NoNewline
        fortsettMeny1
    }

        function sjekkUserExist{
            [string]$finnesbruker = Get-AzureADUser | Where-Object userprincipalname -eq $script:valgtUser
            if ($finnesbruker -eq $null){
                write-host "`nThe UserPrincipalName you entered does not exist!" -ForegroundColor Red
                $fortsettsjekk = read-host "Press <1> to try again or <0> to go back to menu..."
                if ($fortsettsjekk -eq 1){
                    clear-host
                    removeAADUser
                }elseif ($fortsettsjekk -eq 0){
                clear-host
                meny1
                }else{
                clear-host
                write-host "unvalid entry..."
                sjekkUserExist
                }
            }    
        } 

    Function getAADGroup{
        #Funksjonen vil liste ut AAD grupper
        #Funksjonen benytter seg av funksjonen fortsettMeny1
        clear-host
        write-host "========= List AAD groups =========`n" -fore Cyan

        Get-AADGroup | format-table displayName, securityEnabled, createdDateTime
        fortsettMeny1
    } 

    Function getAADGroupMember{
        #Funksjonen vil liste ut brukere i en gruppe (ikke devices)
        #Funksjonen benytter seg av funksjonen fortsettMeny1
        clear-host
        write-host "========= List AAD group members =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter group name: " -fore DarkCyan -NoNewline
        write-host "<0000-1111-2222-3333>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan

        Get-AADGroup | Where-Object securityEnabled -eq 0 | format-table displayName, securityEnabled, createdDateTime
        [string]$gruppenavn = read-host "Skriv inn gruppenavn, for å hente ut brukere"
        

        [string]$gruppeID = get-aadgroup | where-object displayname -eq $gruppenavn | Select-Object -ExpandProperty id 
        Get-AADGroupMember -groupId $gruppeID | format-table givenname, surname, mail

        fortsettMeny1
    } 
        
    function newaadGroup{
        #Funksjonen vil lage en ny AAD gruppe 
        #Funksjonen benytter seg av funksjonen fortsettMeny1 
        clear-host
        write-host "========= Create new AAD group =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter group name: " -fore DarkCyan -NoNewline
        write-host "<Group 001>" -fore Yellow
        write-host "`n========================================`n" -fore cyan

        [string]$gNavn = Read-Host("Enter group name")

        [void](New-AADGroup `
            -displayName $gNavn `
            -mailEnabled 0 `
            -mailNickname $gNavn `
            -securityEnabled 1)
        
        write-host("`nThe group: ") -ForegroundColor cyan -NoNewline
        write-host($gNavn) -ForegroundColor Yellow -NoNewline
        write-host(", has been created!`n") -ForegroundColor cyan -NoNewline
        fortsettMeny1 
    }
    
    function removeAADGroup{
        #Funksjonen vil slette en valgt gruppe
        #Funksjonen benytter seg av funksjonen fortsettMeny1 og sjekkGroupExist
        clear-host
        write-host "========= Delete AAD Group =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter user group name from list above: " -fore DarkCyan -NoNewline
        write-host "<Administrasjon>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan
        Get-AzureADGroup | format-table displayname
        [string]$script:valgtGruppe = read-host "Enter group name from list above"
        
        sjekkGroupExist
        [string]$gruppeID = Get-AzureADgroup | where-object displayname -eq $script:valgtGruppe | Select-Object -ExpandProperty objectid
        
        
        Remove-AADGroup -groupId $gruppeID
        write-host "`nGruppe: " -ForegroundColor Cyan -NoNewline
        write-host $script:valgtGruppe -ForegroundColor Yellow -NoNewline
        write-host ", has been removed!`n" -ForegroundColor Cyan -NoNewline
        fortsettMeny1
    }
    
        function sjekkGroupExist{
            [string]$finnesgruppe = Get-AzureADGroup | Where-Object displayname -eq $script:valgtGruppe
            if ($finnesgruppe -eq $null){
                write-host "`nThe group name you entered does not exist!" -ForegroundColor Red
                $fortsettsjekk = read-host "Press <1> to try again or <0> to go back to menu..."
                if ($fortsettsjekk -eq 1){
                    clear-host
                    removeAADGroup
                }elseif ($fortsettsjekk -eq 0){
                clear-host
                meny1
                }else{
                clear-host
                write-host "unvalid entry..."
                sjekkGroupExist
                }
            }    
        } 

#---------- Operate device ----------

function meny2{
    #Funksjonen laster inn meny for Intune-funksjoner
    #Funksjonen benytter seg av 
    #clear-host
    #nullstillVariabler
    [int]$Menyvalg = 0
    while($Menyvalg -lt 1 -or $Menyvalg -gt 7){
        write-host "`n`t============= ~ Intune Management - Intune Device Management ~ ============= `n" -ForegroundColor Cyan 
        write-host "`t1." -ForegroundColor cyan -NoNewline
        write-host " List Intune/Co-managed devices`n" -ForegroundColor DarkCyan
        write-host "`t2." -ForegroundColor cyan -NoNewline
        write-host " Sync device`n" -ForegroundColor DarkCyan
        write-host "`t3." -ForegroundColor cyan -NoNewline
        write-host " Remote lock a device`n" -ForegroundColor DarkCyan
        write-host "`t4." -ForegroundColor cyan -NoNewline
        write-host " Reset passcode on device`n" -ForegroundColor DarkCyan
        write-host "`t5." -ForegroundColor cyan -NoNewline
        write-host " Retire a device`n" -ForegroundColor DarkCyan
        write-host "`t6." -ForegroundColor cyan -NoNewline
        write-host " Wipe a device`n" -ForegroundColor DarkCyan
        write-host "`t7." -ForegroundColor cyan -NoNewline
        write-host " Restart a device`n" -ForegroundColor DarkCyan
        write-host "`t0. " -fore DarkYellow -NoNewline
        write-host "Back to Intune Management`n" -ForegroundColor DarkYellow

        [int]$Menyvalg = read-host "`tEnter a value between 0 and 7" 
        switch($Menyvalg){
            0{hovedMenyIntune}       
            1{getIntuneDevices}
            2{syncDevice}
            3{remoteLock}
            4{resetPasscode}
            5{retireDevice}
            6{wipeDevice}
            7{restartDevice}
            default{
            clear 
            write-host "Du valgte et tall utenfor menyvalggrensen..." -ForegroundColor yellow
            }
        }
    }
}
    
    function getIntuneDevices{
        #Funksjonen vil liste ut Intune Devices
        #Funksjonen benytter seg av funksjonen fortsettMeny2
        clear-host
        write-host "========= List Intune/Co-managed Devices =========`n" -fore Cyan

        Get-IntuneManagedDevice | Format-Table devicename, deviceEnrollmentType, complianceState  
        fortsettMeny2
    } 

    function syncDevice{
        #Funksjonen vil synkronisere en device
        #Funksjonen benytter seg av funksjonene getDeviceID, fortsettMeny2 
        clear-host
        Get-IntuneManagedDevice | Format-Table devicename, deviceEnrollmentType, complianceState
        write-host "========= Sync Device =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter Device name: " -fore DarkCyan -NoNewline
        write-host "<WIN10G>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan
        
        getDeviceID    
        Invoke-IntuneManagedDeviceSyncDevice `
        -managedDeviceId $script:deviceID 
        
        #clear-host
        write-host "`nDevice: " -ForegroundColor cyan -NoNewline
        write-host $script:deviceName -ForegroundColor Yellow -NoNewline
        Write-Host ", has been synced!`n" -ForegroundColor Cyan -NoNewline
        fortsettMeny2
    } 

    function remoteLock{
        clear-host
        #Funksjonen vil remote lock en device
        #Funksjonen benytter seg av funksjonene getDeviceID, fortsettMeny2 
        Get-IntuneManagedDevice | Format-Table devicename, deviceEnrollmentType, complianceState
        write-host "========= Remote lock a device =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter Device name: " -fore DarkCyan -NoNewline
        write-host "<WIN10_001>" -fore Yellow
        write-host "`n=======================================`n" -fore cyan

        getDeviceID
        Invoke-IntuneManagedDeviceRemoteLock `
        -managedDeviceId $script:deviceID
        
        write-host "`nThe device with name: " -ForegroundColor Cyan -NoNewline
        write-host $deviceName -ForegroundColor Yellow -NoNewline
        write-host ", has been remotely locked!`n" -ForegroundColor Cyan -NoNewline
        fortsettMeny2
    } #fungerer kun på mobiler

    function resetPasscode{
        Clear-Host 
        #Funksjonen vil resette passcode på device 
        #Funksjonen benytter seg av funksjonen getDeviceID, fortsettMeny2
        Get-IntuneManagedDevice | Format-Table devicename, deviceEnrollmentType, complianceState 
        write-host "========= Reset passcode on device =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter Device Name: " -fore DarkCyan -NoNewline
        write-host "<WIN10_001>" -fore Yellow
        write-host "`n===========================================`n" -fore cyan

        getDeviceID
        Invoke-IntuneManagedDeviceResetPasscode `
        -managedDeviceId $script:deviceID
        
        write-host "`nPasscode reset has been initialised on device with name: " -ForegroundColor Cyan -NoNewline
        write-host $script:deviceName -ForegroundColor Yellow -NoNewline
        write-host ".`n" -ForegroundColor Cyan -NoNewline
        fortsettMeny2
    } #fungerer kun på mobiler

    function retireDevice{
        clear-host
        #Funksjonen vil retire en device
        #Funksjonen benytter seg av funksjonen getDEviceID, fortsettMeny2
        Get-IntuneManagedDevice | Format-Table devicename, deviceEnrollmentType, complianceState 
        write-host "========= Retire a device =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter Device Name: " -fore DarkCyan -NoNewline
        write-host "<WIN10_001>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan

        getDeviceID
        Invoke-IntuneManagedDeviceRetire `
        -managedDeviceId $script:deviceID
        
        write-host "`nThe device with name: " -ForegroundColor Cyan -NoNewline
        write-host $script:deviceName -ForegroundColor Yellow -NoNewline
        write-host ", is undergoing retirement`n!" -ForegroundColor Cyan -NoNewline
        fortsettMeny2
    } 

    function wipeDevice{
        Clear-Host
        #Funksjonen vil wipe en device
        #Funksjonen benytter seg av funksjonene getDeviceID, sjekkInputData1, sjekkInputData2, fortsettMeny2 
        Get-IntuneManagedDevice | Format-Table id, devicename 
        write-host "========= Wipe a device =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        #write-host "Enter Device Name: " -fore DarkCyan -NoNewline
        #write-host "WIN10_001>" -fore Yellow
        write-host "KeepEnrolmentData " -fore darkcyan -nonewline
        write-host "<false/true>" -fore yellow
        write-host "KeepUserData " -fore darkcyan -nonewline
        write-host "<false/true>" -fore yellow
        write-host "macOsUnloackCode " -fore darkcyan -nonewline
        write-host "<123456>" -fore yellow -NoNewline
        write-host " NB: Enter "123456" unless you are wiping a Mac OS Device" -ForegroundColor red -BackgroundColor white
        write-host "managedDeviceId " -fore darkcyan -nonewline
        write-host "<123123-123123123-12312312-1231231>" -fore yellow       
        write-host "`n================================`n" -fore cyan

        #getDeviceID
        #sjekkInputData1
        #sjekkInputData2
        
        #[string]$macosCode = read-host "Enter MacOSUnlockCode" 
        
        Invoke-IntuneManagedDeviceWipeDevice #`
        #-keepEnrollmentData $script:sjekkdata1 `
        #-keepUserData $script:sjekkdata2 `
        #-managedDeviceId $script:deviceID `
        #-macOsUnlockCode $macosCode
        
        #write-host "`nThe device with name: " -ForegroundColor Cyan -NoNewline
        #write-host $deviceName -ForegroundColor Yellow -NoNewline
        #write-host ", is undergoing wipe!`n" -ForegroundColor Cyan -NoNewline
        write-host "`nThe device is undergoing wipe!" -fore cyan
        fortsettMeny2
    } 

        function sjekkInputData1{
        [string]$sjekkInput =read-host "Do you want to keep enrollment data? yes or no"
        if ($sjekkInput -eq "yes"){
            $script:sjekkdata1 = $true    
        }elseif ($sjekkInput -eq "no"){
            $script:sjekkdata1 = $false    
        }else{
            write-host "Unvalid input, try again!" -ForegroundColor Red
            clear-host
            sjekkInputData1
        }
    }
    
        function sjekkInputData2{
        [string]$sjekkInput =read-host "Do you want to keep user data? yes or no"
        if ($sjekkInput -eq "yes"){
            $script:sjekkdata2 = 1    
        }elseif ($sjekkInput -eq "no"){
            $script:sjekkdata2 = 0    
        }else{
            write-host "Unvalid input, try again!" -ForegroundColor Red
            clear-host
            sjekkInputData2    
        }
    }

    function restartDevice{
        Clear-Host
        #Funksjonen vil restarte en device
        #Funksjonen benytter seg av funksjonene getDeviceID, fortsettMeny2
        Get-IntuneManagedDevice | Format-Table devicename, deviceEnrollmentType, complianceState 
        write-host "========= Restart a device =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter Device name: " -fore DarkCyan -NoNewline
        write-host "<WIN10_001>" -fore Yellow
        write-host "`n===================================`n" -fore cyan

        getDeviceID
        Invoke-IntuneManagedDeviceRebootNow `
        -managedDeviceId $script:deviceID
               
        write-host "`nThe device with name: " -ForegroundColor Cyan -NoNewline
        write-host $script:deviceName -ForegroundColor Yellow -NoNewline
        write-host ", is restarting!`n" -ForegroundColor Cyan -NoNewline
        fortsettMeny2
    } 

#---------- Windows autopilot ---------- 

function meny3{
    #Funksjonen laster inn meny for Intune-funksjoner
    #Funksjonen benytter seg av 
    
    #nullstillVariabler
    [int]$Menyvalg = 0
    while($Menyvalg -lt 1 -or $Menyvalg -gt 7){
        write-host "`n`t============= ~ Intune Management - Windows Autopilot Management ~ ============= `n" -ForegroundColor Cyan 
        write-host "`t1." -ForegroundColor cyan -NoNewline
        write-host " List Windows Autopilot Devices`n" -ForegroundColor DarkCyan
        write-host "`t2." -ForegroundColor cyan -NoNewline
        write-host " List Windows Autopilot Deployment Profiles`n" -ForegroundColor DarkCyan
        write-host "`t3." -ForegroundColor cyan -NoNewline
        write-host " Assign user to Windows Autopilot Device`n" -ForegroundColor DarkCyan
        write-host "`t4." -ForegroundColor cyan -NoNewline
        write-host " Remove Windows Autopilot Device`n" -ForegroundColor DarkCyan
        write-host "`t5." -ForegroundColor cyan -NoNewline
        write-host " Import single Windows Autopilot Device`n" -ForegroundColor DarkCyan
        write-host "`t6." -ForegroundColor cyan -NoNewline
        write-host " Import Windows Autopilot Devices from .CSV-file`n" -ForegroundColor DarkCyan
        write-host "`t7." -ForegroundColor cyan -NoNewline
        write-host " Sync all Windows Autopilot Devices`n" -ForegroundColor DarkCyan
        write-host "`t0. " -fore darkyellow -NoNewline
        write-host "Back to Intune Management`n" -ForegroundColor DarkYellow

        [int]$Menyvalg = read-host "`tEnter a value between 0 and 7" 
        switch($Menyvalg){
            0{hovedMenyIntune}       
            1{listAutoPilotDevices}
            2{listAutoPilotProfiles}
            3{setAssignedUser}
            4{removeAutopilotdevice}
            5{addSingleAutoPilotDevice}
            6{addAutoPilotDeviceCSV}
            7{syncautopilotdevices}

            default{
            clear 
            write-host "Du valgte et tall utenfor menyvalggrensen..." -ForegroundColor yellow
            }
        }
    }
}

    function listAutoPilotDevices{
        #Funksjonen vil liste ut enheter som er windows autopilot registered
        #Funksjonen benytter seg av funksjonen forsettMeny3
        clear-host
        write-host "========= List Windows Autopilot Devices =========`n" -fore Cyan
        Get-AutoPilotDevice | format-table serialnumber, deploymentprofileassignmentstatus, enrollmentstate, addressableUserName     
        fortsettMeny3
    } 
    
    function listAutoPilotProfiles{
        #Funksjonen vil liste ut Windows Deplyoyment Profiler
        #Funksjonen benytter seg av funksjonen fortsettMeny3
        clear-host
        write-host "========= List Windows Autopilot Deployment Profiles =========`n" -fore Cyan
        Get-AutoPilotProfile | format-table displayname, devicetype
        fortsettMeny3
    } 
    
    function setAssignedUser{
        #Funksjonen vil assignere en bruker til en windows autopilot registrert device.
        #Funksjonen benytter seg av funksjonen fortsettMeny3, sjekkDeviceExist
        clear-host
        write-host "========= Assigner User to Device =========`n" -fore Cyan
        write-host "Eksempel: " -fore DarkCyan 
        write-host "Enter Device ID: " -fore DarkCyan -NoNewline
        write-host "<0000-1111-2222-3333>" -fore Yellow
        write-host "Enter User Principal Name " -fore DarkCyan -NoNewline
        write-host "<bjarneg@alarmnett.no>" -fore Yellow
        write-host "Enter Display Name " -fore DarkCyan -NoNewline
        write-host "<Bjarne G>" -fore Yellow 
        write-host "`n==========================================`n" -fore cyan

        Get-AutoPilotDevice | format-table id, serialnumber, deploymentprofileassignmentstatus, enrollmentstate, addressableUserName     
        [string]$script:autopilotdeviceid = read-host "Enter Device ID"

        Get-AzureADUser | Format-Table UserPrincipalname, DisplayName
        [string]$script:userPName = read-host "Enter User Principal Name"
        [string]$script:displayname = read-host "Enter Display Name"
        
        sjekkDeviceExist
        [void](Set-AutoPilotDeviceAssignedUser `
            -id $script:autopilotdeviceid `
            -userPrincipalName $script:userPName `
            -displayName $script:displayname)
        
        write-host "`nAutopilot device with ID: " -ForegroundColor cyan -NoNewline
        write-host $script:autopilotdeviceid -ForegroundColor Yellow -NoNewline
        write-host ", has been assigned to user: " -ForegroundColor cyan -NoNewline
        write-host $script:displayname -ForegroundColor yellow -NoNewline
        write-host ".`n" -ForegroundColor Cyan -NoNewline
        fortsettMeny3
    } 

        function sjekkDeviceExist{
            [string]$deviceIDSjekk = Get-AutoPilotDevice | Where-Object id -eq $script:autopilotdeviceid | Select-Object -ExpandProperty serialnumber
            [string]$userpdisplaysjekk = Get-AzureADUser | where-object userPrincipalname -eq $script:userpname 
            if($deviceIDSjekk -eq $null){
                write-host "The device does not exist!" -ForegroundColor red
                $fortsettsjekk = read-host "Press <1> to try again or <0> to go back to menu..."
                if ($fortsettsjekk -eq 1){
                    clear-host
                    setAssignedUser
                }elseif ($fortsettsjekk -eq 0){
                    clear-host
                    meny3
                }else{
                    clear-host
                    write-host "unvalid entry..."
                    sjekkDeviceExist
                }
            }elseif($userpdisplaysjekk -eq $null){
                write-host "The user does not exist!" -ForegroundColor red
                $fortsettsjekk = read-host "Press <1> to try again or <0> to go back to menu..."
                if ($fortsettsjekk -eq 1){
                    clear-host
                    setAssignedUser
                }elseif ($fortsettsjekk -eq 0){
                    clear-host
                    meny3
                }else{
                    clear-host
                    write-host "unvalid entry..."
                    sjekkDeviceExist    
                }
            }
        } 

    function removeAutopilotdevice{
        #Funksjonen vil slette en Windows Autopilot Device
        #Funksjonen benytter seg av funksjonen fortsettMeny3, sjekkAPDExist
        clear-host
        write-host "========= Remove Windows Autopilot Device =========`n" -fore Cyan
        write-host "Eksempel: " -fore DarkCyan 
        write-host "Enter Device ID: " -fore DarkCyan -NoNewline
        write-host "<0000-1111-2222-3333>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan
        
        Get-AutoPilotDevice | format-table ID, serialnumber, addressableUserName, ismanaged     
        $script:deviceID = read-host "Enter Device ID"

        sjekkAPDExist 
        try{
            Remove-AutoPilotDevice -id $script:deviceID 
        }catch{
            write-host "`nThe Windows Autopilot Device can not be removed, because it has client" -ForegroundColor Red 
            write-host "registration status as Registered with 'IsManaged' status 'True', or" -ForegroundColor Red
            write-host "the deletion is allready in progress.`n"
            fortsettMeny3                 
        }
        
        write-host "`nAutopilot Device with ID: " -ForegroundColor cyan -NoNewline
        write-host $script:deviceID -ForegroundColor Yellow -NoNewline
        write-host ", has been removed!`n" -ForegroundColor Cyan -NoNewline 
        fortsettMeny3
    } 

        function sjekkAPDExist{
            $fortsettsjekk = Get-AutoPilotDevice | where-object id -eq $script:deviceID 
            if($fortsettsjekk -eq $null){
                clear-host
                write-host "The Device you're trying to delete does not exist!" -ForegroundColor Red
                $fortsettsjekk = read-host "Press <1> to try again or <0> to go back to menu..."
                if ($fortsettsjekk -eq 1){
                    clear-host
                    removeAutopilotdevice
                }elseif ($fortsettsjekk -eq 0){
                clear-host
                meny3
                }else{
                clear-host
                write-host "unvalid entry..."
                sjekkDeviceExist
                }
            }
        } 

    function addSingleAutoPilotDevice{
        #Funksjonen vil legge til en Windows Autopilot Device
        #Funksjonen benytter seg av funksjonen fortsettMeny3
        clear-host
        write-host "========= Legg til Windows Autopilot Device =========`n" -fore Cyan
        write-host "Eksempel: " -fore DarkCyan 
        write-host "Enter Serial Number: " -fore DarkCyan -NoNewline
        write-host "<0000-1111-2222-3333>" -fore Yellow
        write-host "Enter order identifier: " -fore DarkCyan -NoNewline
        write-host "<>" -fore Yellow
        write-host "Enter Hardware Identifier: " -fore DarkCyan -NoNewline
        write-host "<00000000000awdawdwd00000000>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan
        [string]$serialNumber = read-host "Enter Serial Number"
        [string]$orderID = read-host "Enter order identifier"
        [string]$hardwareID = read-host "Enter Hardware Identifier"
        
        [void](Add-AutoPilotImportedDevice `
            -serialNumber $serialNumber `
            -hardwareIdentifier $hardwareID `
            -orderIdentifier $orderID)
        
        
        Write-host "`nDevice with serial number: " -ForegroundColor Cyan -NoNewline
        write-host $serialNumber -ForegroundColor Yellow -NoNewline
        write-host ", has been added to Windows Autopilot registered devices!`n" -ForegroundColor cyan -NoNewline
        fortsettMeny3
    }

    function addAutoPilotDeviceCSV{
        #Funksjonen vil legge til Windows Autopilot Devices fra en .CSV-fil
        #Funksjonen benytter seg av funksjonen fortsettMeny3
        clear-host
        write-host "========= Legg til Windows Autopilot Devices fra .CSV-fil =========`n" -fore Cyan
        write-host "Eksempel: " -fore DarkCyan 
        write-host "Choose .CSV file-path, ENTER to continue... " -fore DarkCyan -NoNewline
        write-host "<Trykker ENTER og velger .CSV-fil>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan
        
        read-host "Choose .CSV file-path, ENTER to continue..."
        
        Add-Type -AssemblyName System.Windows.Forms
        $openFileDialog = New-Object System.Windows.Forms.OpenFileDialog
        $openFileDialog.Title = $WindowTitle
        
        $openFileDialog.ShowDialog()
        [void](Import-AutoPilotCSV `
            -csvFile $openFileDialog.FileNames)
        
        Write-Host "`nFile: " -ForegroundColor Cyan -NoNewline
        Write-Host $openFileDialog.FileName -ForegroundColor Yellow -NoNewline
        Write-Host ", containing devices, has been added to Windows Autopilot registered devices!`n" -ForegroundColor Cyan -NoNewline 
        fortsettMeny3
    } 

    function syncautopilotdevices{
        #Funksjonen vil synkronisere alle Windows Autopilot Devices
        #Funksjonen benytter seg av funksjonen fortsettMeny3
        Clear-Host
        Invoke-AutopilotSync
        
        Clear-Host
        write-host "========= Sync all Windows Autopilot Devices =========`n" -fore Cyan
        Write-Host "Windows Autopilot registered devices have been synced!`n" -ForegroundColor yellow -NoNewline
        fortsettMeny3
    } 

#---------- Device compliance ---------- 

function meny4{
    #Funksjonen laster inn meny for Device Compliance 
    #Funksjonen benytter seg av hovedMenyIntune, listComPolicy, newComPolicy, assignCompPolicy 
    #clear-host
    [int]$Menyvalg = 0
    while($Menyvalg -lt 1 -or $Menyvalg -gt 4){
        write-host "`n`t============= ~ Intune Management - Compliance Policy Management ~ ============ `n" -ForegroundColor Cyan 
        write-host "`t1." -ForegroundColor cyan -NoNewline
        write-host " List Device Compliance Policies`n" -ForegroundColor DarkCyan
        write-host "`t2." -ForegroundColor cyan -NoNewline
        write-host " Create new Device Compliance Policy`n" -ForegroundColor DarkCyan
        write-host "`t3." -ForegroundColor cyan -NoNewline
        write-host " Remove Device Compliance Policy`n" -ForegroundColor DarkCyan
        write-host "`t4." -ForegroundColor cyan -NoNewline
        write-host " Assign Compliance Policy to Group`n" -ForegroundColor DarkCyan
        write-host "`t0. " -fore yellow -NoNewline
        write-host "Back to Intune Management`n" -ForegroundColor DarkYellow

        [int]$Menyvalg = read-host "`tEnter a value between 0 and 4" 
        switch($Menyvalg){
            0{hovedMenyIntune}       
            1{listCompPolicy}
            2{newCompPolicy}
            3{removeCompPolicy}
            4{assignCompPolicy}
            default{
            clear 
            write-host "Du valgte et tall utenfor menyvalggrensen..." -ForegroundColor yellow
            }
        }
    }
}

    function listCompPolicy{
        #Funksjonen vil liste ut alle DEvice Compliance Policies
        #Funksjonen benytter seg av funksjonen fortsettMeny4
        clear-host
        write-host "========= List Device Compliance Policies =========`n" -fore Cyan
        Get-IntuneDeviceCompliancePolicy | format-table displayname
        fortsettMeny4
    } 

    function newCompPolicy{
        #Funksjonen vil opprette en ny device Compliance Policy
        #Funksjonen benytter seg av funksjonen fortsettMeny4
        clear-host
        write-host "========= Create new Compliance Policy =========`n" -fore Cyan
        write-host "Eksempel: " -fore DarkCyan 
        write-host "Enter name of Compliance Policy:" -fore DarkCyan -NoNewline
        write-host " <Compliance_Policy_001>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan
        write-host "NB:" -ForegroundColor red -BackgroundColor Black -NoNewline
        write-host " Funksjonen oppretter en ferdigoppsatt Compliance Policy."
        write-host "Hensikten med denne funksjonen er å demonstrere at det er"
        write-host "mulig å gjøre slike operasjoner med Powershell.`n"
        $compName = read-host "Enter name of Compliance Policy" 

        [void](New-IntuneDeviceCompliancePolicy `
            -windows10CompliancePolicy `
            -displayName $compName `
            -osMinimumVersion 10.0.16299 `
            -scheduledActionsForRule `
            (New-DeviceComplianceScheduledActionForRuleObject `
                -ruleName PasswordRequired `
                -scheduledActionConfigurations `
                (New-DeviceComplianceActionItemObject `
                    -gracePeriodHours 0 `
                    -actionType block `
                    -notificationTemplateId "" `
                ) `
            ))

        #Clear-Host
        Write-Host "`nDevice Compliance Policy, med navnet: " -ForegroundColor Cyan -NoNewline
        Write-Host $compName -ForegroundColor Yellow -NoNewline
        Write-Host ", har blitt opprettet!`n" -ForegroundColor Cyan -NoNewline
        fortsettMeny4
    } 

    function removeCompPolicy{
        #Funksjonen vil slette en Device Compliance Policy
        #Funksjonen benytter seg av funksjonen fortsettMeny og sjekkComExist
        clear-host
        write-host "========= Remove Compliance Policy =========`n" -fore Cyan
        write-host "Eksempel: " -fore DarkCyan 
        write-host "Enter name of Compliance Policy:" -fore DarkCyan -NoNewline
        write-host " <Compliance_Policy_001>" -fore Yellow
        write-host "`n==========================================`n" -fore cyan
        
        Get-IntuneDeviceCompliancePolicy | format-table displayname
        $script:compName = read-host "Enter name of Compliance Policy"
        [string]$compID = Get-IntuneDeviceCompliancePolicy | where-object displayName -eq $script:compName | Select-Object -ExpandProperty id
        
        sjekkCompExist
        Remove-IntuneDeviceCompliancePolicy `
            -deviceCompliancePolicyId $compID
        
        Write-Host "`nDevice Compliance Policy, by the name: " -ForegroundColor Cyan -NoNewline
        Write-Host $script:compName -ForegroundColor Yellow -NoNewline
        Write-Host ", has been deleted!`n" -ForegroundColor cyan -NoNewline
        fortsettMeny4 
    } 
        
        function sjekkCompExist{
            [string]$finnesComp = Get-IntuneDeviceCompliancePolicy | where-object displayname -eq $script:compName
            if ($finnesComp -eq $null){
                
                write-host "`nThe Compliance Policy you entered does not exist!" -ForegroundColor Red
                $fortsettsjekk = read-host "Press <1> to try again or <0> to go back to menu..."
                if ($fortsettsjekk -eq 1){
                    clear-host
                    removeCompPolicy
                }elseif ($fortsettsjekk -eq 0){
                clear-host
                meny5
                }else{
                clear-host
                write-host "unvalid entry..."
                sjekkCompExist
                }
            }    
        } 

    function assignCompPolicy{
        #Funksjonen vil assignere device Compliance Policies
        #Funksjonen benytter seg av funksjonen fortsettMeny4 og sjekkCompExist2
        clear-host
        write-host "========= Compliance Policy Management - Assign Compliance Policy to Group =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter name of Compliance Policy:" -fore DarkCyan -NoNewline
        write-host " <Comp_Policy_001>" -fore Yellow
        write-host "Enter name of group:" -fore DarkCyan -NoNewline
        write-host " <gruppe_001>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan

        Get-IntuneDeviceCompliancePolicy | Format-Table displayname
        [string]$complName = read-host "Enter name of Compliance Policy"
        $complID = Get-IntuneDeviceCompliancePolicy | Where-Object displayname -eq $complName | Select-Object -ExpandProperty id


        
        Get-AADGroup | Format-Table displayname
        [string]$gruppeNavn = read-host "Enter name of group"

        [string]$groupID = Get-AADGroup | Where-Object displayname -eq $gruppeNavn | select-object -ExpandProperty id
        
        Invoke-IntuneDeviceCompliancePolicyAssign `
            -deviceCompliancePolicyId $complID `
            -assignments `
            (New-DeviceCompliancePolicyAssignmentObject `
                -target `
                (New-DeviceAndAppManagementAssignmentTargetObject `
                    -groupAssignmentTarget `
                    -groupId $groupID `
                ) `
            )

        write-host "`Compliance Policy with name: " -ForegroundColor Cyan -NoNewline
        write-host $complName -ForegroundColor yellow -NoNewline
        write-host ", has been assigned to group: " -ForegroundColor Cyan -NoNewline
        write-host $gruppeNavn -ForegroundColor Yellow -NoNewline
        write-host ".`n" -ForegroundColor Cyan -NoNewline

        fortsettMeny4 
    }
        
        function sjekkCompExist2{
            if ($script:complID -eq $null){
                clear-host
                write-host "The Compliance Policy you entered does not exist!" -ForegroundColor Red
                $fortsettsjekk = read-host "Press <1> to try again or <0> to go back to menu..."
                if ($fortsettsjekk -eq 1){
                    clear-host
                    assignCompPolicy
                }elseif ($fortsettsjekk -eq 0){
                clear-host
                meny5
                }else{
                clear-host
                write-host "unvalid entry..."
                sjekkCompExist2
                }
            }
        }

#---------- Device configuration ---------- 

function meny5{
    #Funksjonen laster inn meny for Intune-funksjoner
    #Funksjonen benytter seg av 
    #clear-host
    #nullstillVariabler
    [int]$Menyvalg = 0
    while($Menyvalg -lt 1 -or $Menyvalg -gt 4){
        write-host "`n`t============= ~ Intune Management - Configuration Policy Management ~ ============ `n" -ForegroundColor Cyan 
        write-host "`t1." -ForegroundColor cyan -NoNewline
        write-host " List Device Configuration Policies`n" -ForegroundColor DarkCyan
        write-host "`t2." -ForegroundColor cyan -NoNewline
        write-host " Create new Device Confiugration Policy`n" -ForegroundColor DarkCyan
        write-host "`t3." -ForegroundColor cyan -NoNewline
        write-host " Remove Device Configuration Policy`n" -ForegroundColor DarkCyan
        write-host "`t4." -ForegroundColor cyan -NoNewline
        write-host " Assign Configuration Policy to Group`n" -ForegroundColor DarkCyan
        write-host "`t0. " -fore yellow -NoNewline
        write-host "Back to Intune Management`n" -ForegroundColor DarkYellow

        [int]$Menyvalg = read-host "`tEnter a value between 0 and 4" 
        switch($Menyvalg){
            0{hovedMenyIntune}       
            1{listConfPolicy}
            2{newConfPolicy}
            3{removeConfPolicy}
            4{assignConfPolicy}
            default{
            clear 
            write-host "Du valgte et tall utenfor menyvalggrensen..." -ForegroundColor yellow
            }
        }
    }
}

    function listConfPolicy{
        #Funksjonen vil liste ut alle Device Configuration Policies
        #Funksjonen benytter seg av funksjonen fortsettMeny5
        clear-host
        write-host "========= List Device Configuration Policies =========`n" -fore Cyan
        Get-IntuneDeviceConfigurationPolicy | format-table displayname, description
        fortsettMeny5
    } 

    function newConfPolicy{
        #Funksjonen vil opprette en ny Device Configuration Policy
        #Funksjonen benytter seg av funksjonen platformvalg
        clear-host
        write-host "========= Create new Configuration Policy =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter name of Configuration Policy:" -fore DarkCyan -NoNewline
        write-host " <Configuration_Policy_001>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan
        
        write-host "NB:" -ForegroundColor red -BackgroundColor Black -NoNewline
        write-host " Funksjonen oppretter en ferdigoppsatt Configuration Policy." -ForegroundColor DarkCyan
        write-host "Hensikten med denne funksjonen er å demonstrere at det er" -ForegroundColor DarkCyan
        write-host "mulig å gjøre slike operasjoner med Powershell.`n" -ForegroundColor DarkCyan
        $script:confName = read-host "Enter name of Configuration Policy" 
        
        write-host "`n1. Windows 10 Policy" -ForegroundColor DarkCyan
        write-host "2. Android Policy" -ForegroundColor DarkCyan
        write-host "3. iOS Policy`n" -ForegroundColor DarkCyan
             
        platformvalg 
    } 
        
        function platformvalg{
            [int]$policyPlatform = read-host "Choose platform"
            if ($policyPlatform -eq 1){
                [void](new-IntuneDeviceConfigurationPolicy `
                    -windows10GeneralConfiguration `
                    -displayName $script:confName `
                    -startMenuHideShutDown 1)
                
                write-host "`nConfiguration Policy med navn: " -ForegroundColor Cyan -NoNewline
                write-host $script:confName -ForegroundColor Yellow -NoNewline
                write-host ", has been created!`n" -ForegroundColor Cyan -NoNewline
                fortsettMeny5        
            }elseif ($policyPlatform -eq 2){
                [void](new-IntuneDeviceConfigurationPolicy `
                    -androidGeneralDeviceConfiguration `
                    -displayName $script:confName `
                    -bluetoothBlocked 1)

                write-host "`nConfiguration Policy med navn: " -ForegroundColor Cyan -NoNewline
                write-host $script:confName -ForegroundColor Yellow -NoNewline
                write-host ", has been created!" -ForegroundColor Cyan -NoNewline
                fortsettMeny5   
            }elseif ($policyPlatform -eq 3){
                [void](new-IntuneDeviceConfigurationPolicy `
                    -iosGeneralDeviceConfiguration `
                    -displayName $script:confName `
                    -cameraBlocked 1)
                
                write-host "`nConfiguration Policy med navn: " -ForegroundColor Cyan -NoNewline
                write-host $script:confName -ForegroundColor Yellow -NoNewline
                write-host ", has been created!" -ForegroundColor Cyan -NoNewline
                fortsettMeny5 
            }else{
                write-host "Feil input, velg 1, 2 eller 3!" -ForegroundColor Red
                platformvalg 
            }
        } 

    function removeConfPolicy{
        #Funksjonen vil slette en Device Configuration Policy
        #Funksjonen benytter seg av funksjonen fortsettMeny5, sjekkConfExist
        clear-host
        write-host "========= Remove Configuration Policy =========`n" -fore Cyan
        write-host "Eksempel: " -fore DarkCyan 
        write-host "Enter name of Configuration Policy:" -fore DarkCyan -NoNewline
        write-host " <Configuration_Policy_001>" -fore Yellow
        write-host "`n==========================================`n" -fore cyan
        
        Get-IntuneDeviceConfigurationPolicy | format-table displayname
        $script:confName = read-host "Enter name of Configuration Policy"
        [string]$confID = Get-IntuneDeviceConfigurationPolicy | where-object displayName -eq $confName | Select-Object -ExpandProperty id
        
        sjekkConfExist
        Remove-IntuneDeviceConfigurationPolicy `
            -deviceConfigurationId $confID
        
        Write-Host "`nDevice Configuration Policy, med navnet: " -ForegroundColor Cyan -NoNewline
        Write-Host $script:confName -ForegroundColor Yellow -NoNewline
        Write-Host ", har blitt slettet!`n" -ForegroundColor Cyan -NoNewline
        fortsettMeny5
    } 
        
        function sjekkConfExist{
            [string]$finnesConf = Get-IntuneDeviceConfigurationPolicy | where-object displayname -eq $script:confName
            if ($finnesConf -eq $null){
                write-host "`nThe Configuration Policy you entered does not exist!" -ForegroundColor Red
                $fortsettsjekk = read-host "Press <1> to try again or <0> to go back to menu..."
                if ($fortsettsjekk -eq 1){
                    clear-host
                    removeConfPolicy
                }elseif ($fortsettsjekk -eq 0){
                clear-host
                meny5
                }else{
                clear-host
                write-host "unvalid entry..."
                sjekkConfExist
                }
            }
        } 

    function assignConfPolicy{
        #Funksjonen vil assignere device Compliance Policies
        #Funksjonen benytter seg av funksjonen fortsettMeny4
        
        clear-host
        write-host "========= Configuration Policy Management - Assign Configuration Policy to Group =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter name of Configuration Policy:" -fore DarkCyan -NoNewline
        write-host " <Conf_Policy_001>" -fore Yellow
        write-host "Enter name of group:" -fore DarkCyan -NoNewline
        write-host " <gruppe_001>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan

        Get-IntuneDeviceConfigurationPolicy | Format-Table displayname
        [string]$confName = read-host "Enter name of Configuration Policy"

        Get-AADGroup | Format-Table displayname
        [string]$gruppeNavn = read-host "Enter name of group"

        [string]$groupID = Get-AADGroup | Where-Object displayname -eq $gruppeNavn | select-object -ExpandProperty id
        [string]$confID = Get-IntuneDeviceConfigurationPolicy | Where-Object displayname -eq $confName | Select-Object -ExpandProperty id

        New-IntuneDeviceConfigurationPolicyAssignment `
            -deviceConfigurationId $confID `
                    -target (New-DeviceAndAppManagementAssignmentTargetObject `
                                -groupAssignmentTarget `
                                -groupId $groupID)


        write-host "`Configuration Policy with name: " -ForegroundColor Cyan -NoNewline
        write-host $confName -ForegroundColor yellow -NoNewline
        write-host ", has been assigned to group: " -ForegroundColor Cyan -NoNewline
        write-host $gruppeNavn -ForegroundColor Yellow -NoNewline
        write-host ".`n" -ForegroundColor Cyan -NoNewline

        fortsettMeny5
         
    }
    
#---------- Client apps ----------

function meny6{
    #Funksjonen laster inn meny for Intune-funksjoner
    #Funksjonen benytter seg av 
    #clear-host
    #nullstillVariabler
    [int]$Menyvalg = 0
    while($Menyvalg -lt 1 -or $Menyvalg -gt 4){
        write-host "`n`t============= ~ Intune Management - Client Apps Management ~ ============ `n" -ForegroundColor Cyan 
        write-host "`t1." -ForegroundColor cyan -NoNewline
        write-host " Create new application`n" -ForegroundColor DarkCyan
        write-host "`t2." -ForegroundColor cyan -NoNewline
        write-host " Remove app`n" -ForegroundColor DarkCyan
        write-host "`t3." -ForegroundColor cyan -NoNewline
        write-host " Assign Application to Group`n" -ForegroundColor DarkCyan
        write-host "`t0. " -fore yellow -NoNewline
        write-host "Back to Intune Management`n" -ForegroundColor DarkYellow

        [int]$Menyvalg = read-host "`tEnter a value between 0 and 3" 
        switch($Menyvalg){
            0{hovedMenyIntune}       
            1{newAppMeny}
            2{removeIntuneApp}
            3{assignApp}
            default{
            clear 
            write-host "Du valgte et tall utenfor menyvalggrensen..." -ForegroundColor yellow
            }
        }
    }
}

    function newAppMeny{
    #Funksjonen laster inn meny for Intune-funksjoner
    #Funksjonen benytter seg av 
    
    [int]$Menyvalg = 0
    while($Menyvalg -lt 1 -or $Menyvalg -gt 3){
        write-host "`n`t`t========================= ~ Client Apps Management - Create new application ~ ========================= `n" -ForegroundColor Cyan 
        write-host "`t`t1." -ForegroundColor cyan -NoNewline
        write-host " Android Mobile App`n" -ForegroundColor DarkCyan
        write-host "`t`t2." -ForegroundColor cyan -NoNewline
        write-host " Apple iOS App`n" -ForegroundColor DarkCyan
        write-host "`t`t3." -ForegroundColor cyan -NoNewline
        write-host " Win MSI App`n" -ForegroundColor DarkCyan
        write-host "`t`t0." -fore yellow -NoNewline
        write-host " Back to Client Apps Management`n" -ForegroundColor DarkYellow

        [int]$Menyvalg = read-host "`t`tEnter a value between 0 and 3" 
        switch($Menyvalg){
            0{Meny5}       
            1{androidApp}
            2{iOSApp}
            3{winMobileMsiApp}
            default{
            clear 
            write-host "Du valgte et tall utenfor menyvalggrensen..." -ForegroundColor yellow
            }
        }
    }
}

        function iOSApp{
        #Funksjonen laster oppretter en iOSApp
        #Funksjonen benytter seg av fortsettmeny6 og sjekkiffeatured
        clear-host
        write-host "========= Create new Apple iOS Application =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Displayname:" -fore DarkCyan -NoNewline
        write-host " <Apple_App_001>" -fore Yellow
        write-host "Description:" -fore DarkCyan -NoNewline
        write-host " <Apple app>" -fore Yellow
        write-host "Publisher:" -fore DarkCyan -NoNewline
        write-host " <Squaresoft>" -fore Yellow
        write-host "App Store URL" -fore DarkCyan -NoNewline
        write-host " <https://itunes.apple.com/us/app/snapchat/id447188370?mt=8>" -fore Yellow
        write-host "Add Application to Application catalog? <yes> or <no>" -fore DarkCyan -NoNewline
        write-host " <yes>"
        write-host "`n=================================================`n" -fore cyan
        
        [string]$dNavn = read-host("Displayname")
        [string]$description = read-host("Description")
        [string]$publisher = read-host("Publisher")
        [string]$appstoreUrl = read-host("App Store URL")
        [int]$script:isfeatured = 0

        sjekkiffeatured
        [void](new-IntuneMobileApp `
            -iosStoreApp `
            -displayName $dNavn `
            -description $description `
            -publisher $publisher `
            -appStoreUrl $appstoreUrl `
            -minimumSupportedOperatingSystem (New-IosMinimumOperatingSystemObject -v8_0 $true) `
            -isFeatured $script:isfeatured `
            -applicableDeviceType (New-IosDeviceTypeObject -ipad 1 -iPhoneAndIPod 1))
        
        write-host "`nApplikasjonen med navnet: " -ForegroundColor DarkCyan -NoNewline
        write-host $dNavn -ForegroundColor Yellow -NoNewline
        write-host ", har blitt opprettet!`n" -ForegroundColor Darkcyan -NoNewline
        fortsettMeny6    
        }

        function winMobileMsiApp{
        #Funksjonen laster oppretter en winmobilemsiapp
        #Funksjonen benytter seg av fortsettmeny6 og sjekkiffeatured
        clear-host
        write-host "========= Create new Win Mobile MSI Application =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Displayname:" -fore DarkCyan -NoNewline
        write-host " <WIN_APP_001>" -fore Yellow
        write-host "Description:" -fore DarkCyan -NoNewline
        write-host " <WIN-app app>" -fore Yellow
        write-host "Publisher:" -fore DarkCyan -NoNewline
        write-host " <Squaresoft>" -fore Yellow
        write-host "MSI file path" -fore DarkCyan -NoNewline
        write-host " <C:\msifile>" -fore Yellow
        write-host "Add Application to Application catalog? <yes> or <no>" -fore DarkCyan -NoNewline
        write-host " <yes>" -fore Yellow
        write-host "Enter Product version> or <no>" -fore DarkCyan -NoNewline
        write-host " <Newest version>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan
        
        [string]$dNavn = read-host("Displayname")
        [string]$description = read-host("Description")
        [string]$publisher = read-host("Publisher")
        [string]$filepath = read-host("MSI file path")
        [string]$productversion = read-host ("Enter Product version")
        [int]$script:isfeatured = 0

        sjekkiffeatured
        [void](new-IntuneMobileApp `
            -windowsMobileMSI `
            -displayName $dNavn `
            -description $description `
            -publisher $publisher `
            -isFeatured $script:isfeatured `
            -fileName $filepath `
            -productVersion $productversion)
    
        
        write-host "`nApplikasjonen med navnet: " -ForegroundColor DarkCyan -NoNewline
        write-host $dNavn -ForegroundColor Yellow -NoNewline
        write-host ", har blitt opprettet!`n" -ForegroundColor Darkcyan -NoNewline
        fortsettMeny6    
        }
        
        function androidApp{
        #Funksjonen laster oppretter en androidapp
        #Funksjonen benytter seg av fortsettmeny6 og sjekkiffeatured
        clear-host
        write-host "========= Create new Android Application =========`n" -fore Cyan
        write-host "Eksempel: " -fore DarkCyan 
        write-host "Displayname:" -fore DarkCyan -NoNewline
        write-host " <Andorid_App_001>" -fore Yellow
        write-host "Description:" -fore DarkCyan -NoNewline
        write-host " <Andorid app>" -fore Yellow
        write-host "Publisher:" -fore DarkCyan -NoNewline
        write-host " <Squaresoft>" -fore Yellow
        write-host "App Sotre URL" -fore DarkCyan -NoNewline
        write-host " <www.google.play.store.com/awdadrgdg>" -fore Yellow
        write-host "Add Application to Application catalog? <yes> or <no>" -fore DarkCyan -NoNewline
        write-host " <yes>"
        write-host "`n=================================================`n" -fore cyan
        
        [string]$dNavn = read-host("Displayname")
        [string]$description = read-host("Description")
        [string]$publisher = read-host("Publisher")
        [string]$appstoreUrl = read-host("App Store URL")
        [int]$script:isfeatured = 0

        sjekkiffeatured
        [void](new-IntuneMobileApp `
            -androidStoreApp `
            -displayName $dNavn `
            -description $description `
            -publisher $publisher `
            -appStoreUrl $appstoreUrl `
            -minimumSupportedOperatingSystem (New-AndroidMinimumOperatingSystemObject -v4_0 $true) `
            -isFeatured $script:isfeatured)
    
        
        write-host "`nApplikasjonen med navnet: " -ForegroundColor DarkCyan -NoNewline
        write-host $dNavn -ForegroundColor Yellow -NoNewline
        write-host ", har blitt opprettet!`n" -ForegroundColor Darkcyan -NoNewline
        fortsettMeny6
    
    } 
            
            function sjekkiffeatured{
            [string]$isfeaturedsjekk = read-host ("Add Application to Application catalog? <yes> or <no>")
            if($isfeaturedsjekk -eq "yes"){
                $script:isfeatured = 1
            }elseif($isfeaturedsjekk -eq "no"){
                $script:isfeatured = 0    
            }else{
                clear-host
                write-host "False input, try again..." -ForegroundColor Red
                sjekkiffeatured
            }
        } 

    function removeIntuneApp{
        #Funksjonen vil slette en Intune app
        #Funksjonen benytter seg av funksjonen fortsettMeny6 og sjekkAppExist
        clear-host
        write-host "========= Delete Intune Application =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter name of application to remove:" -fore DarkCyan -NoNewline
        write-host " <Andorid_App_001>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan

        Get-IntuneMobileApp | format-table displayname, mobileAppId
        [string]$script:appName = read-host "Enter name of application to remove" 
        sjekkAppExist

        [string]$appID = Get-IntuneMobileApp | Where-Object displayName -eq $script:appName | Select-Object -ExpandProperty mobileAppId 
        
        
        Remove-IntuneMobileApp -mobileAppId $appID
         
        write-host "`nApplication: " -ForegroundColor Cyan -NoNewline
        write-host $script:appName -ForegroundColor Yellow -NoNewline
        write-host ", has been removed!`n" -ForegroundColor Cyan -NoNewline
        fortsettMeny6
    } 
        
        function sjekkAppExist{
            [string]$finnesapp = Get-IntuneMobileApp | Where-Object displayname -eq $script:appName
            if ($finnesapp -eq $null){
                clear-host
                write-host "`nThe application name you entered does not exist!" -ForegroundColor Red
                $fortsettsjekk = read-host "Press <1> to try again or <0> to go back to menu..."
                if ($fortsettsjekk -eq 1){
                    clear-host
                    removeIntuneApp
                }elseif ($fortsettsjekk -eq 0){
                clear-host
                meny6
                }else{
                clear-host
                write-host "unvalid entry..."
                sjekkAppExist
                }
            }
        } 

    Function assignApp{
        clear-host
        write-host "========= Client Apps Management - Assign App to Group =========`n" -fore Cyan
        write-host "Example: " -fore DarkCyan 
        write-host "Enter name of mobile app:" -fore DarkCyan -NoNewline
        write-host " <Apple_App_001>" -fore Yellow
        write-host "Enter name of group:" -fore DarkCyan -NoNewline
        write-host " <gruppe_001>" -fore Yellow
        write-host "`n=================================================`n" -fore cyan

        Get-IntuneMobileApp | Format-Table displayname
        [string]$appNavn = read-host "Enter name of mobile app"

        Get-AADGroup | Format-Table displayname
        [string]$gruppeNavn = read-host "Enter name of group"

        [string]$groupID = Get-AADGroup | Where-Object displayname -eq $gruppeNavn | select-object -ExpandProperty id
        [string]$appID = Get-IntuneMobileApp | Where-Object displayname -eq $appNavn | Select-Object -ExpandProperty id

        Invoke-IntuneMobileAppAssign `
            -mobileAppId $appID `
            -mobileAppAssignments (New-MobileAppAssignmentObject `
                                    -intent required `
                                    -target (New-DeviceAndAppManagementAssignmentTargetObject `
                                                -groupAssignmentTarget `
                                                -groupId $groupID))


        write-host "`nApp with name: " -ForegroundColor Cyan -NoNewline
        write-host $appNavn -ForegroundColor yellow -NoNewline
        write-host ", has been assigned to group: " -ForegroundColor Cyan -NoNewline
        write-host $gruppeNavn -ForegroundColor Yellow -NoNewline
        write-host ".`n" -ForegroundColor Cyan -NoNewline

        fortsettMeny6
    }

#---------- Tilleggsfunksjoner ----------

Function fortsettMeny1{
    #Funksjonen brukes til å spørre brukeren om han ønsker å fortsette eller ikke.
    #Funksjonen benytter seg av 
    write-host "`nGå tilbake til menyvalg? " -fore DarkCyan -NoNewline
    write-host "<" -fore DarkCyan -NoNewline
    write-host "j" -fore Yellow -NoNewline
    write-host ">" -fore DarkCyan -NoNewline
    $sjekkcontinue = read-host "`n"
    if($sjekkContinue -eq "j"){
        clear-host
        meny1    
    }
    else{
        fortsettMeny1
    }     
}

Function fortsettMeny2{
    #Funksjonen brukes til å spørre brukeren om han ønsker å fortsette eller ikke.
    #Funksjonen benytter seg av 
    write-host "`nGå tilbake til menyvalg? " -fore DarkCyan -NoNewline
    write-host "<" -fore DarkCyan -NoNewline
    write-host "j" -fore Yellow -NoNewline
    write-host ">" -fore DarkCyan -NoNewline
    $sjekkcontinue = read-host "`n"
    if($sjekkContinue -eq "j"){
        clear-host
        meny2    
    }
    else{
        fortsettMeny2
    }     
}

Function fortsettMeny3{
    #Funksjonen brukes til å spørre brukeren om han ønsker å fortsette eller ikke.
    #Funksjonen benytter seg av 
    write-host "`nGå tilbake til menyvalg? " -fore DarkCyan -NoNewline
    write-host "<" -fore DarkCyan -NoNewline
    write-host "j" -fore Yellow -NoNewline
    write-host ">" -fore DarkCyan -NoNewline
    $sjekkcontinue = read-host "`n"
    if($sjekkContinue -eq "j"){
        clear-host
        meny3    
    }
    else{
        fortsettMeny3
    }     
}

Function fortsettMeny4{
    #Funksjonen brukes til å spørre brukeren om han ønsker å fortsette eller ikke.
    #Funksjonen benytter seg av 
    write-host "`nGå tilbake til menyvalg? " -fore DarkCyan -NoNewline
    write-host "<" -fore DarkCyan -NoNewline
    write-host "j" -fore Yellow -NoNewline
    write-host ">" -fore DarkCyan -NoNewline
    $sjekkcontinue = read-host "`n"
    if($sjekkContinue -eq "j"){
        clear-host
        meny4   
    }
    else{
        fortsettMeny4
    }     
}

Function fortsettMeny5{
    #Funksjonen brukes til å spørre brukeren om han ønsker å fortsette eller ikke.
    #Funksjonen benytter seg av 
    write-host "`nGå tilbake til menyvalg? " -fore DarkCyan -NoNewline
    write-host "<" -fore DarkCyan -NoNewline
    write-host "j" -fore Yellow -NoNewline
    write-host ">" -fore DarkCyan -NoNewline
    $sjekkcontinue = read-host "`n"
    if($sjekkContinue -eq "j"){
        clear-host
        meny5    
    }
    else{
        fortsettMeny5
    }     
}

Function fortsettMeny6{
    #Funksjonen brukes til å spørre brukeren om han ønsker å fortsette eller ikke.
    #Funksjonen benytter seg av 
    write-host "`nGå tilbake til menyvalg? " -fore DarkCyan -NoNewline
    write-host "<" -fore DarkCyan -NoNewline
    write-host "j" -fore Yellow -NoNewline
    write-host ">" -fore DarkCyan -NoNewline
    $sjekkcontinue = read-host "`n"
    if($sjekkContinue -eq "j"){
        clear-host
        meny6   
    }
    else{
        fortsettMeny6
    }     
}

function avslutt{
    #Funksjonen brukes til å avslutte scriptet, sletter pssessions, og kjører oppkobling på nytt.
    #Funksjonen benytter seg av funksjonene oppkobling, hovedMeny.
    write-host "Er du sikker på at du vil avslutte? " -fore DarkCyan -nonewline
    write-host "'j'" -fore cyan -NoNewline
    write-host " for ja, "-fore DarkCyan -NoNewline
    write-host "'n'" -fore Cyan -NoNewline
    write-host " for nei." -fore DarkCyan
    $valg = read-host "<j> or <n>"
    if ($valg -eq "j") {
        clear-host
        Remove-PSSession -Session (Get-PSSession)
        clear-host
        Exit(1)
    }
    elseif ($valg -eq "n") {
        clear-host 
        hovedMenyAD
    }    
}

hovedmenyIntune
